#ifndef ONI_H
#define ONI_H

#include "stdint.h"
#include <stdio.h>
#include <windows.h>
#include <GL/gl.h>

#define ONICALL __fastcall

// The following headers were written when Daodan used -fpack-struct, and
// should be rewritten
#pragma pack(push, 1)
#include "stdtypes.h"
#include "BFW_Motoko_Draw.h"
#include "BFW_ScriptLang.h"
#include "Character.h"
#include "GameState.h"
#include "GL.h"
#include "OBJt.h"
#pragma pack(pop)

#include "Input.h"

#define DDmAssert(expr) assert(expr);

#define WMcMessage_Quit 0x39 // WM_QUIT equivalent.

typedef struct {
	HINSTANCE Instance;
	HWND Window;
} ONtPlatformData;

typedef struct {
	int16_t left;
	int16_t top;
	int16_t right;
	int16_t bottom;
} UUtRect;

#include "Symbols_Var.h"
#include "Symbols_Func.h"

#endif
